-- =====================================
-- Author      : Txty
-- Create Date : 9/23/2014 12:27:36 AM
-- =====================================
local ADDON_NAME, namespace = ...
local ab = namespace.ab
local eots = namespace.eots
local dwg = namespace.dwg
local tbfg = namespace.tbfg
local ssm = namespace.ssm
local bgframe = {ab, dwg, ssm, eots, tbfg}
-------------------------------------
local DEFAULT_SETTINGS = {
    -- We will use the "char" section, which is specific to each character
    char = {
        -- No need to append "default" to all names
		setPointx = nil,
		setPointy = nil,
	}
}
-------------------------------------
BGCallouts = LibStub("AceAddon-3.0"):NewAddon("BGCallouts", "AceConsole-3.0", "AceEvent-3.0" );
-------------------------------------
function BGCallouts:OnInitialize()
	-- Called when the addon is loaded
	BGCallouts:Print("Loaded")
	-- Initialize the database
	local i = 1
		while bgframe[i] do
			bgframe[i].db = LibStub('AceDB-3.0'):New("BGCalloutsDB", DEFAULT_SETTINGS)
			bgframe[i]:SetPoint("CENTER", UIParent, "CENTER", bgframe[i].db.char.setPointx, bgframe[i].db.char.setPointy)
			i = i + 1
		end
end

BGCallouts.show = function()
	local i = 1
		while bgframe[i] do
			bgframe[i]:Show(true)
			i = i + 1
		end
	return end

BGCallouts.hide = function()
	local i = 1
		while bgframe[i] do
			bgframe[i]:Hide(true)
			i = i + 1
		end
	return end

BGCallouts.func = function(self,n,_,_,_,_,_,_,iid)
--	   BGCallouts:Print(iid)
	if (iid==529) then
		ab:Show(true)
	elseif (iid==1105) then
		dwg:Show(true)
	elseif (iid==761) then
		tbfg:Show(true)
	elseif (iid==566) then
		eots:Show(true)
	elseif (iid==727) then
		ssm:Show(true)
	else
		BGCallouts:hide()
	end
return end

-- Slash commands
SLASH_BGC1 = "/BGCallouts"
SlashCmdList["BGC"] = function (msg)
	if (msg=="show") then
		BGCallouts:show()	
	elseif (msg=="hide") then
		BGCallouts:hide()
	else
		BGCallouts:Print("Only works with 'show' or 'hide'.")
	end
end

function BGCallouts:OnEnable()
		-- Called when the addon is enabled
		-- Print a message to the chat frame
		-- self:Print("OnEnable Event Fired: Hello, again ;)")
		BGCallouts:hide()
		self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
		BGCallouts:func(GetInstanceInfo())
end

function BGCallouts:OnDisable()
		-- Called when the addon is disabled
end

function BGCallouts:ZONE_CHANGED_NEW_AREA()
	BGCallouts:func(GetInstanceInfo())
end