-- Author      : Txty
-- Create Date : 9/23/2014 12:27:36 AM
-------------------------------------
local ADDON_NAME, namespace = ...
local L = namespace.L
---------------------
-- Create Frames
---------------------
local bgframe = {'ab','dwg','ssm','eots','tbfg'}
	for i = 1, 5 do
		bgframe[i] = CreateFrame("FRAME", bgframe[i], UIParent)
	end
namespace.ab = ab
namespace.eots = eots
namespace.dwg = dwg
namespace.tbfg = tbfg
namespace.ssm = ssm
-----------------------------------
-- Frame
-------------------------------------
local function SetupBGFrame(frame)
   frame:SetMovable(true)
   frame:EnableMouse(true)
   frame:RegisterForDrag("LeftButton")
   frame:SetScript("OnDragStart", frame.StartMoving)
   frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
-- frame:SetPoint("CENTER", UIParent, "CENTER")
-- The code below makes the frame visible
   frame.texture = frame:CreateTexture("ARTWORK")
   frame.texture:SetAllPoints()
   frame.texture:SetTexture(0, 0, 0, 1)
   return frame
end
---------------------
SetupBGFrame(ab)
ab:SetSize(48, 208)
---------------------
SetupBGFrame(dwg)
dwg:SetSize(48, 128)
---------------------
SetupBGFrame(ssm)
eots:SetSize(48, 168)
---------------------
SetupBGFrame(eots)
tbfg:SetSize(48, 128)
---------------------
SetupBGFrame(tbfg)
ssm:SetSize(48, 128)
-------------------------------------
-- Buttons
-------------------------------------
local function LocationButton_OnClick(self, mouseButton)
   local name = self.location
   local icon, message
   if mouseButton == "LeftButton" then
      icon, message = "{rt8}", L["needs help!!!"]
   else
      icon, message = "{rt4}", L["is safe."]
   end
   SendChatMessage(format("%s %s %s", icon, name, message), "INSTANCE_CHAT")
end
-------------------------------------
local function AddLocationButton(bgFrame, name, texture)
   local button = CreateFrame("Button", nil, bgFrame)
   button:SetSize(40, 40)
   button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
   button:SetScript("OnClick", LocationButton_OnClick)

   -- Store the location name on the button:
   button.location = name
   -- Apply the specified texture:
   button:SetNormalTexture("Interface/AddOns/BGCallouts/Icons/"..texture)

   -- Store the button on the frame:
   bgFrame.locations = bgFrame.locations or {}
   tinsert(bgFrame.locations, button)

   -- Automatically place the button:
   local i = #bgFrame.locations
   if i == 1 then
      -- This is the first button on this frame, attach it to the top:
      button:SetPoint("TOPLEFT", 4, -4)
   else
      -- Attach it to the bottom of the previous button:
      button:SetPoint("TOPLEFT", bgFrame.locations[i-1], "BOTTOMLEFT")
   end
	
   return button
end
-------------------------------------
-- Arathi Basin
AddLocationButton(ab, L["Farm"], "farm")
AddLocationButton(ab, L["Mine"], "mine")
AddLocationButton(ab, L["Blacksmith"], "blacksmith")
AddLocationButton(ab, L["Lumber Mill"], "lumbermill")
AddLocationButton(ab, L["Stable"], "stable")
-- Eye of the Storm
AddLocationButton(eots, L["Fel Reaver ruins"], "felreaver")
AddLocationButton(eots, L["Mage tower"], "magetower")
AddLocationButton(eots, L["Draenei ruins"], "draenei")
AddLocationButton(eots, L["Blood Elf tower"], "bloodelf")
-- Deepwind Gorge
AddLocationButton(dwg, L["Pandaren Mine"], "pandaren")
AddLocationButton(dwg, L["Center Mine"], "center")
AddLocationButton(dwg, L["Goblin Mine"], "goblin")
-- The Battle for Gilneas
AddLocationButton(tbfg, L["Mine"], "mine")
AddLocationButton(tbfg, L["Lighthouse"], "lighthouse")
AddLocationButton(tbfg, L["Waterworks"], "waterworks")
-- Silvershards Mines
AddLocationButton(ssm, L["Lava cart"], "lava")
AddLocationButton(ssm, L["Oil cart"], "oil")
AddLocationButton(ssm, L["Lake cart"], "lake")
-- END ------------------------------